#auto_version

#import <shaders/include/text.glsl>

const float STRIKE_MIN_Y = 3.0 / float(PIXELS_PER_CHAR);
const float STRIKE_MAX_Y = 4.0 / float(PIXELS_PER_CHAR);

const float UNDERLINE_MIN_Y = 7.0 / float(PIXELS_PER_CHAR);
// not actually used, because it is redundant (8.0 is the max for localTexCoord0Y)
const float UNDERLINE_MAX_Y = 8.0 / float(PIXELS_PER_CHAR);

uniform sampler2D Sampler0;

centroid in vec2 vUV;
/**
 * [0.0, 8.0]
 */
in float vLocalV;
in vec4 vColor;
flat in float vBold;
flat in float vStrike;
flat in float vUnderline;

out vec4 fragColor;

float samplePixel(vec2 uv) {
    return texture(Sampler0, vUV).a;
}

void main() {
    float regularFilled = samplePixel(vUV);
    float boldFilled = vBold * samplePixel(vUV - vec2(SUPER_PIXEL, 0.0));

    // step(-STRIKE_MAX_Y, -vLocalV) == 1.0 - step(STRIKE_MAX_Y, vLocalV)
    bool strikeFilled = bool(vStrike * step(STRIKE_MIN_Y, vLocalV) * step(-STRIKE_MAX_Y, -vLocalV));
    bool underlineFilled = bool(vUnderline * step(UNDERLINE_MIN_Y, vLocalV));

    float filled = max(max(regularFilled, boldFilled), float(any(bvec2(strikeFilled, underlineFilled))));
    fragColor = vColor * vec4(1.0, 1.0, 1.0, filled);
}
