package dev.pfaff.altargui.util;

import org.jspecify.annotations.Nullable;

import java.util.function.Consumer;

public record LinkedNode<T>(T value, @Nullable LinkedNode<T> next) {
	public LinkedNode(T value) {
		this(value, null);
	}

	public void forEach(Consumer<T> consumer) {
		var node = this;
		do {
			consumer.accept(node.value);
		} while ((node = node.next) != null);
	}

	public static <T> void forEach(@Nullable LinkedNode<T> node, Consumer<T> consumer) {
		while (node != null) {
			consumer.accept(node.value);
			node = node.next;
		}
	}
}
